Loading...
Searching...
No Matches
Opm::H2O< Scalar > Class Template Reference

Material properties of pure water . More...

`#include <H2O.hpp>`

Inheritance diagram for Opm::H2O< Scalar >:

## Static Public Member Functions

static std::string_view | name ()
| A human readable name for the water.
static const Scalar | molarMass ()
| The molar mass in of water.
static const Scalar | acentricFactor ()
| The acentric factor of water.
static const Scalar | criticalTemperature ()
| Returns the critical temperature of water.
static const Scalar | criticalPressure ()
| Returns the critical pressure of water.
static const Scalar | criticalVolume ()
| Returns the critical volume of water.
static const Scalar | criticalMolarVolume ()
| Returns the molar volume of water at the critical point.
static const Scalar | tripleTemperature ()
| Returns the temperature at water's triple point.
static const Scalar | triplePressure ()
| Returns the pressure at water's triple point.
template<class Evaluation>
static Evaluation | vaporPressure (Evaluation temperature)
| The vapor pressure in of pure water at a given temperature.
template<class Evaluation>
static Evaluation | vaporTemperature (const Evaluation &pressure)
| The vapor temperature in of pure water at a given pressure.
template<class Evaluation>
static Evaluation | gasEnthalpy (const Evaluation &temperature, const Evaluation &pressure)
| Specific enthalpy of water steam .
template<class Evaluation>
static Evaluation | liquidEnthalpy (const Evaluation &temperature, const Evaluation &pressure)
| Specific enthalpy of liquid water .
template<class Evaluation>
static Evaluation | gasHeatCapacity (const Evaluation &temperature, const Evaluation &pressure)
| Specific isobaric heat capacity of water steam .
template<class Evaluation>
static Evaluation | liquidHeatCapacity (const Evaluation &temperature, const Evaluation &pressure)
| Specific isobaric heat capacity of liquid water .
template<class Evaluation>
static Evaluation | liquidInternalEnergy (const Evaluation &temperature, const Evaluation &pressure)
| Specific internal energy of liquid water .
template<class Evaluation>
static Evaluation | gasInternalEnergy (const Evaluation &temperature, const Evaluation &pressure)
| Specific internal energy of steam and water vapor .
template<class Evaluation>
static Evaluation | liquidHeatCapacityConstVolume (const Evaluation &temperature, const Evaluation &pressure)
| Specific isochoric heat capacity of liquid water .
template<class Evaluation>
static Evaluation | gasHeatCapacityConstVolume (const Evaluation &temperature, const Evaluation &pressure)
| Specific isochoric heat capacity of steam and water vapor .
static bool | gasIsCompressible ()
| Returns true iff the gas phase is assumed to be compressible.
static bool | liquidIsCompressible ()
| Returns true iff the liquid phase is assumed to be compressible.
template<class Evaluation>
static Evaluation | gasDensity (const Evaluation &temperature, const Evaluation &pressure)
| The density of steam in at a given pressure and temperature.
static bool | gasIsIdeal ()
| Returns true iff the gas phase is assumed to be ideal.
template<class Evaluation>
static Evaluation | gasPressure (const Evaluation &temperature, Scalar density)
| The pressure of steam in at a given density and temperature.
template<class Evaluation>
static Evaluation | liquidDensity (const Evaluation &temperature, const Evaluation &pressure, bool extrapolate=false)
| The density of pure water in at a given pressure and temperature.
template<class Evaluation>
static Evaluation | liquidPressure (const Evaluation &temperature, Scalar density)
| The pressure of liquid water in at a given density and temperature.
template<class Evaluation>
static Evaluation | gasViscosity (const Evaluation &temperature, const Evaluation &pressure)
| The dynamic viscosity of steam.
template<class Evaluation>
static Evaluation | liquidViscosity (const Evaluation &temperature, const Evaluation &pressure, bool extrapolate=false)
| The dynamic viscosity of pure water.
template<class Evaluation>
static Evaluation | liquidThermalConductivity (const Evaluation &temperature, const Evaluation &pressure)
| Thermal conductivity of water (IAPWS) .
template<class Evaluation>
static Evaluation | gasThermalConductivity (const Evaluation &temperature, const Evaluation &pressure)
| Thermal conductivity of water (IAPWS) .
Static Public Member Functions inherited from Opm::Component< Scalar, H2O< Scalar > >
static void | init (Scalar, Scalar, unsigned, Scalar, Scalar, unsigned)
| A default routine for initialization, not needed for components and must not be called.
static bool | gasIsCompressible ()
| Returns true iff the gas phase is assumed to be compressible.
static bool | gasIsIdeal ()
| Returns true iff the gas phase is assumed to be ideal.
static bool | liquidIsCompressible ()
| Returns true iff the liquid phase is assumed to be compressible.
static std::string_view | name ()
| A human readable name for the component.
static Scalar | molarMass ()
| The molar mass in of the component.
static Scalar | criticalTemperature ()
| Returns the critical temperature in of the component.
static Scalar | criticalPressure ()
| Returns the critical pressure in of the component.
static Scalar | acentricFactor ()
| Returns the acentric factor of the component.
static Scalar | criticalVolume ()
| Returns the critical volume in of the component.
static Scalar | tripleTemperature ()
| Returns the temperature in at the component's triple point.
static Scalar | triplePressure ()
| Returns the pressure in at the component's triple point.
static Evaluation | vaporPressure (const Evaluation &)
| The vapor pressure in of the component at a given temperature in .
static Evaluation | gasDensity (const Evaluation &, const Evaluation &)
| The density in of the component at a given pressure in and temperature in .
static Evaluation | liquidDensity (const Evaluation &, const Evaluation &)
| The density of the liquid component at a given pressure in and temperature in .
static Evaluation | gasEnthalpy (const Evaluation &, const Evaluation &)
| Specific enthalpy of the pure component in gas.
static Evaluation | liquidEnthalpy (const Evaluation &, const Evaluation &)
| Specific enthalpy of the pure component in liquid.
static Evaluation | gasInternalEnergy (const Evaluation &, const Evaluation &)
| Specific internal energy of the pure component in gas.
static Evaluation | liquidInternalEnergy (const Evaluation &, const Evaluation &)
| Specific internal energy of pure the pure component in liquid.
static Evaluation | gasViscosity (const Evaluation &, const Evaluation &)
| The dynamic viscosity of the pure component at a given pressure in and temperature in .
static Evaluation | liquidViscosity (const Evaluation &, const Evaluation &)
| The dynamic liquid viscosity of the pure component.
static Evaluation | gasThermalConductivity (const Evaluation &, const Evaluation &)
| Thermal conductivity of the component [W/(m^2 K/m)] as a gas.
static Evaluation | liquidThermalConductivity (const Evaluation &, const Evaluation &)
| Thermal conductivity of the component [W/(m^2 K/m)] as a liquid.
static Evaluation | gasHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a gas.
static Evaluation | liquidHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a liquid.

## Additional Inherited Members

Public Types inherited from Opm::Component< Scalar, H2O< Scalar > >
typedef Scalar | Scalar
Static Public Attributes inherited from Opm::Component< Scalar, H2O< Scalar > >
static constexpr bool | isTabulated

## Detailed Description

template<class Scalar>
class Opm::H2O< Scalar >

Material properties of pure water .

Template Parameters

  Scalar | The type used for scalar values

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

## Member Function Documentation

## gasDensity()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::gasDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The density of steam in at a given pressure and temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## gasEnthalpy()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::gasEnthalpy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific enthalpy of water steam .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## gasHeatCapacity()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::gasHeatCapacity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific isobaric heat capacity of water steam .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## gasHeatCapacityConstVolume()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::gasHeatCapacityConstVolume | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific isochoric heat capacity of steam and water vapor .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## gasInternalEnergy()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::gasInternalEnergy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific internal energy of steam and water vapor .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## gasPressure()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::gasPressure | ( | const Evaluation & | temperature,
|  | Scalar | density )

inline static

The pressure of steam in at a given density and temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  density | Density in

## gasThermalConductivity()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::gasThermalConductivity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Thermal conductivity of water (IAPWS) .

Implementation taken from: freesteam - IAPWS-IF97 steam tables library Copyright (C) 2004-2009 John Pye

Appendix B: Recommended Interpolating equation for Industrial Use see http://www.iapws.org/relguide/thcond.pdf

Parameters

  temperature | Absolute temperature in K
  pressure | Phase pressure of the phase in Pa

## gasViscosity()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::gasViscosity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The dynamic viscosity of steam.

This method is only valid if pressure is below or at the vapor pressure of water.

See:

IAPWS: "Release on the IAPWS Formulation 2008 for the Viscosity of Ordinary Water Substance", http://www.iapws.org/relguide/visc.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## liquidDensity()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::liquidDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | bool | extrapolate = false )

inline static

The density of pure water in at a given pressure and temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in
  extrapolate | True to use extrapolation

## liquidEnthalpy()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::liquidEnthalpy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific enthalpy of liquid water .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## liquidHeatCapacity()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::liquidHeatCapacity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific isobaric heat capacity of liquid water .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## liquidHeatCapacityConstVolume()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::liquidHeatCapacityConstVolume | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific isochoric heat capacity of liquid water .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## liquidInternalEnergy()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::liquidInternalEnergy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific internal energy of liquid water .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## liquidPressure()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::liquidPressure | ( | const Evaluation & | temperature,
|  | Scalar | density )

inline static

The pressure of liquid water in at a given density and temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  density | Density of the fluid in

## liquidThermalConductivity()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::liquidThermalConductivity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Thermal conductivity of water (IAPWS) .

Implementation taken from: freesteam - IAPWS-IF97 steam tables library Copyright (C) 2004-2009 John Pye

Appendix B: Recommended Interpolating equation for Industrial Use see http://www.iapws.org/relguide/thcond.pdf

Parameters

  temperature | Absolute temperature in K
  pressure | Phase pressure of the phase in Pa

## liquidViscosity()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::liquidViscosity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | bool | extrapolate = false )

inline static

The dynamic viscosity of pure water.

See:

IAPWS: "Release on the IAPWS Formulation 2008 for the Viscosity of Ordinary Water Substance", http://www.iapws.org/relguide/visc.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in
  extrapolate | True to use extrapolation

## vaporPressure()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::vaporPressure | ( | Evaluation | temperature | ) |

inline static

The vapor pressure in of pure water at a given temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the system in

## vaporTemperature()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::H2O< Scalar >::vaporTemperature | ( | const Evaluation & | pressure | ) |

inline static

The vapor temperature in of pure water at a given pressure.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  pressure | Phase pressure in

The documentation for this class was generated from the following file:

- opm/material/components/H2O.hpp